
( $priorityFile ) = @ARGV;

$collapsed = 1;

$priority{'intergenic'} = 0;

open(USRFL, "<", $priorityFile) or die "Can't open $priorityFile\n";
while(<USRFL>) {
	chomp $_;
	if( $_ !~ /^\#/ && $_ !~ /trailing/ ) {
		if( /^(\w.+):/ ) { $type = $1; }
		elsif( /priority\s\:\s(\d+)/ ) { $priority{$type} = $1; }
	}
}
close USRFL;

while(<STDIN>) {
	chomp $_;
	my @line = split(/\,/, $_);
	if( exists( $priority{$line[4]}) ) {
		if( $priority{$line[4]} >= $best{$line[@line - 1]} ) {
			$best{$line[@line - 1]} = $priority{$line[4]};
		}
	} elsif( $line[4] !~ /Aligned/ ) { die "PROBLEM: '$line[4]' not found in priority file\n"; }
}
close STDIN;

foreach my $read ( keys(%best) ) {
	my $count = 1;
	if( $collapsed ) {
		if( $read =~ /\d+\-(\d+)/ ) { $count = $1; }
	}
	$total{$best{$read}} += $count;
}

foreach my $type (sort hashValueDescendingNum keys(%priority) ) {
	if( $type ne "tss" && $type ne "tes" ) {
		if( exists($total{$priority{$type}}) ) {
			print "$type:\t$total{$priority{$type}}\n";
		} else { print "$type:\t0\n"; }
	}
}

sub hashValueDescendingNum {
	$priority{$b} <=> $priority{$a}
}
