import subprocess
import re
from optparse import OptionParser

#runBowtie.py -b ${BOWTIE_DIRECTORY} -i ${BOWTIE_INDEX} -p ${MAXIMUM_NUMBER_OF_THREADS} -o ${OUTPUT_DIRECTORY}bowtie/ -F ${LIBRARY_NAME}

commandLineParser = OptionParser()
commandLineParser.add_option("-b", action="store", type="string", dest="bowtieDirectory")
commandLineParser.add_option("-i", action="store", type="string", dest="bowtieIndex")
commandLineParser.add_option("-p", action="store", type="string", dest="maximumNumberOfThreads")
commandLineParser.add_option("-o", action="store", type="string", dest="outputDirectory")
commandLineParser.add_option("-F", action="store", type="string", dest="outputFilePrefix")
commandLineParser.add_option("-f", action="store", type="string", dest="inputFASTAfile")
commandLineParser.add_option("-c", action="store", type="string", dest="alignmentCutoff")
(commandLineOptions, args) = commandLineParser.parse_args()

def runBowtie(cmd, alignmentCutoff, samOutputFile, nonAlignedOutputFile, reAlignOutputFile):
    print "Command: "+cmd+"\n"
    
    bowtieProcess = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE)
    stdout = []
    
    
    samTypeFile = open(samOutputFile, 'a')
    notAlignedFile = open(nonAlignedOutputFile, 'a')
    if int(alignmentCutoff) > -12: reAlignFile = open(reAlignOutputFile, 'w')
    
    line = ''
    lineData = []
    currentReadID = ' '
    currentReadOutput = ''
    numberOfReadsNotAligned = 0
    numberOfReadAlignmentsForCurrentRead = 0
    while True:
        line = bowtieProcess.stdout.readline()
        stdout.append(line)
        
        if line == '' and bowtieProcess.poll() != None: break       
             
        if re.search("^[\@HD|\@SQ]", line): 
            if alignmentCutoff == '0': samTypeFile.write(line)
        else:
            
            lineData = line.split('\t')
            if lineData[0] == currentReadID:
                currentReadOutput += line
                numberOfReadAlignmentsForCurrentRead += 1
                
            else:
                if len(currentReadOutput) > 0 :
                    if numberOfReadAlignmentsForCurrentRead <= 10: samTypeFile.write(currentReadOutput)
                    else: notAlignedFile.write(">"+currentReadID+"\n"+lineData[9]+"\n")
                
                currentReadID = lineData[0]
                numberOfReadAlignmentsForCurrentRead = 1;
                currentReadOutput = line
                if lineData[1] == '4':
                    
                    if int(alignmentCutoff) > -12: reAlignFile.write(">"+currentReadID+"\n"+lineData[9]+"\n")
                    else: notAlignedFile.write(">"+currentReadID+"\n"+lineData[9]+"\n")
                    
                    currentReadOutput = ''
                    numberOfReadAlignmentsForCurrentRead = 0;
   
   
    if len(currentReadOutput) > 0 & numberOfReadAlignmentsForCurrentRead <= 10:
        samTypeFile.write(currentReadOutput)


    notAlignedFile.close()
    samTypeFile.close()
    if int(alignmentCutoff) > -12: reAlignFile.close()
    
    return 0




runBowtie(
          commandLineOptions.bowtieDirectory+
          'bowtie2-align '+
          commandLineOptions.bowtieIndex+
          ' -k 11 -f -U '+
          commandLineOptions.inputFASTAfile+
          ' -p '+
          commandLineOptions.maximumNumberOfThreads+
          ' --score-min C,'+
          commandLineOptions.alignmentCutoff+
          ' --rdg 0,6 --rfg 13,1', 
          commandLineOptions.alignmentCutoff,
          commandLineOptions.outputDirectory+commandLineOptions.outputFilePrefix+'.sam',
          commandLineOptions.outputDirectory+commandLineOptions.outputFilePrefix+'_notAligned.fasta',
          commandLineOptions.outputDirectory+commandLineOptions.outputFilePrefix+'_reAlign'+ commandLineOptions.alignmentCutoff+'.fasta',
          )

